# Uses of Class
org.springframework.http.HttpHeaders

Packages that use HttpHeaders
Package
Description
org.springframework.http
Contains a basic abstraction over client/server-side HTTP.
org.springframework.http.client
Contains an abstraction over client-side HTTP.
org.springframework.http.client.reactive
Abstractions for reactive HTTP client support including `ClientHttpRequest` and `ClientHttpResponse` as well as a `ClientHttpConnector`.
org.springframework.http.client.support
This package provides generic HTTP support classes, to be used by higher-level classes like RestTemplate.
org.springframework.http.codec.multipart
Multipart support.
org.springframework.http.converter
Provides an HttpMessageConverter abstraction to convert between Java objects and HTTP input/output messages.
org.springframework.http.converter.json
Provides HttpMessageConverter implementations for handling JSON.
org.springframework.http.converter.xml
Provides HttpMessageConverter implementations for handling XML.
org.springframework.http.server
Contains an abstraction over server-side HTTP.
org.springframework.http.server.reactive
Abstractions for reactive HTTP server support including a `ServerHttpRequest` and `ServerHttpResponse` along with an `HttpHandler` for processing.
org.springframework.web
Common, generic interfaces that define minimal boundary points between Spring's web infrastructure and other framework modules.
org.springframework.web.client
Core package of the client-side web support.
org.springframework.web.client.support
Classes supporting the `org.springframework.web.client` package.
org.springframework.web.multipart
Multipart resolution framework for handling file uploads.
org.springframework.web.multipart.support
Support classes for the multipart resolution framework.
org.springframework.web.server
Core interfaces and classes for Spring's generic, reactive web support.
org.springframework.web.service.invoker
Support for creating a client proxy for an HTTP service annotated with `HttpExchange` methods.
org.springframework.web.util
Miscellaneous web utility classes, such as HTML escaping and cookie handling.

## Uses of HttpHeaders in org.springframework.http

Fields in org.springframework.http declared as HttpHeaders
Modifier and Type
Field
Description
`static final HttpHeaders`
HttpHeaders.`EMPTY`
An empty `HttpHeaders` instance (immutable).
Methods in org.springframework.http that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
HttpEntity.`getHeaders()`
Returns the headers of this entity.
`HttpHeaders`
HttpMessage.`getHeaders()`
Return the headers of this message.
`static HttpHeaders`
HttpHeaders.`readOnlyHttpHeaders(HttpHeaders headers)`
Apply a read-only `HttpHeaders` wrapper around the given headers, if necessary.
`static HttpHeaders`
HttpHeaders.`readOnlyHttpHeaders(org.springframework.util.MultiValueMap<String,String> headers)`
Apply a read-only `HttpHeaders` wrapper around the given headers, if necessary.
`static HttpHeaders`
HttpHeaders.`writableHttpHeaders(HttpHeaders headers)`
Deprecated, for removal: This API element is subject to removal in a future version.
as of 6.2 in favor of `HttpHeaders(MultiValueMap)`.
Methods in org.springframework.http with parameters of type HttpHeaders
Modifier and Type
Method
Description
`B`
RequestEntity.HeadersBuilder.`headers(HttpHeaders headers)`
Copy the given headers into the entity's headers map.
`B`
ResponseEntity.HeadersBuilder.`headers(HttpHeaders headers)`
Copy the given headers into the entity's headers map.
`static HttpHeaders`
HttpHeaders.`readOnlyHttpHeaders(HttpHeaders headers)`
Apply a read-only `HttpHeaders` wrapper around the given headers, if necessary.
`static HttpHeaders`
HttpHeaders.`writableHttpHeaders(HttpHeaders headers)`
Deprecated, for removal: This API element is subject to removal in a future version.
as of 6.2 in favor of `HttpHeaders(MultiValueMap)`.
Method parameters in org.springframework.http with type arguments of type HttpHeaders
Modifier and Type
Method
Description
`B`
RequestEntity.HeadersBuilder.`headers(Consumer<HttpHeaders> headersConsumer)`
Manipulate this entity's headers with the given consumer.
`B`
ResponseEntity.HeadersBuilder.`headers(Consumer<HttpHeaders> headersConsumer)`
Manipulate this entity's headers with the given consumer.

## Uses of HttpHeaders in org.springframework.http.client

Methods in org.springframework.http.client that return HttpHeaders
Modifier and Type
Method
Description
`final HttpHeaders`
AbstractClientHttpRequest.`getHeaders()`
Methods in org.springframework.http.client with parameters of type HttpHeaders
Modifier and Type
Method
Description
`protected abstract ClientHttpResponse`
AbstractClientHttpRequest.`executeInternal(HttpHeaders headers)`
Abstract template method that writes the given headers and content to the HTTP request.
`protected abstract OutputStream`
AbstractClientHttpRequest.`getBodyInternal(HttpHeaders headers)`
Abstract template method that returns the body.
Method parameters in org.springframework.http.client with type arguments of type HttpHeaders
Modifier and Type
Method
Description
`MultipartBodyBuilder.PartBuilder`
MultipartBodyBuilder.PartBuilder.`headers(Consumer<HttpHeaders> headersConsumer)`
Manipulate the part headers through the given consumer.

## Uses of HttpHeaders in org.springframework.http.client.reactive

Methods in org.springframework.http.client.reactive that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
AbstractClientHttpRequest.`getHeaders()`
`HttpHeaders`
AbstractClientHttpResponse.`getHeaders()`
`HttpHeaders`
ClientHttpRequestDecorator.`getHeaders()`
`HttpHeaders`
ClientHttpResponseDecorator.`getHeaders()`
`protected HttpHeaders`
AbstractClientHttpRequest.`initReadOnlyHeaders()`
Initialize the read-only headers after the request is committed.
Constructors in org.springframework.http.client.reactive with parameters of type HttpHeaders
Modifier
Constructor
Description
``
`AbstractClientHttpRequest(HttpHeaders headers)`
`protected`
`AbstractClientHttpResponse(HttpStatusCode statusCode, HttpHeaders headers, org.springframework.util.MultiValueMap<String,ResponseCookie> cookies, reactor.core.publisher.Flux<org.springframework.core.io.buffer.DataBuffer> body)`

## Uses of HttpHeaders in org.springframework.http.client.support

Methods in org.springframework.http.client.support that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
HttpRequestWrapper.`getHeaders()`
Return the headers of the wrapped request.

## Uses of HttpHeaders in org.springframework.http.codec.multipart

Methods in org.springframework.http.codec.multipart that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
Part.`headers()`
Return the headers associated with the part.
`HttpHeaders`
PartEvent.`headers()`
Return the headers of the part that this event belongs to.
Methods in org.springframework.http.codec.multipart with parameters of type HttpHeaders
Modifier and Type
Method
Description
`protected reactor.core.publisher.Mono<org.springframework.core.io.buffer.DataBuffer>`
MultipartWriterSupport.`generatePartHeaders(HttpHeaders headers, org.springframework.core.io.buffer.DataBufferFactory bufferFactory)`
Method parameters in org.springframework.http.codec.multipart with type arguments of type HttpHeaders
Modifier and Type
Method
Description
`static reactor.core.publisher.Flux<FilePartEvent>`
FilePartEvent.`create(String partName, String filename, MediaType contentType, reactor.core.publisher.Flux<org.springframework.core.io.buffer.DataBuffer> contents, Consumer<HttpHeaders> headersConsumer)`
Creates a stream of `FilePartEvent` objects based on the given name, FilePartEvent.filename(), content-type, and contents.
`static reactor.core.publisher.Flux<FilePartEvent>`
FilePartEvent.`create(String name, Path path, Consumer<HttpHeaders> headersConsumer)`
Creates a stream of `FilePartEvent` objects based on the given name and file path.
`static reactor.core.publisher.Flux<FilePartEvent>`
FilePartEvent.`create(String name, org.springframework.core.io.Resource resource, Consumer<HttpHeaders> headersConsumer)`
Creates a stream of `FilePartEvent` objects based on the given name and resource.
`static reactor.core.publisher.Mono<FormPartEvent>`
FormPartEvent.`create(String name, String value, Consumer<HttpHeaders> headersConsumer)`
Creates a stream with a single `FormPartEven` based on the given name and value.

## Uses of HttpHeaders in org.springframework.http.converter

Methods in org.springframework.http.converter with parameters of type HttpHeaders
Modifier and Type
Method
Description
`protected void`
AbstractHttpMessageConverter.`addDefaultHeaders(HttpHeaders headers, T t, MediaType contentType)`
Add default headers to the output message.
`protected void`
StringHttpMessageConverter.`addDefaultHeaders(HttpHeaders headers, String s, MediaType type)`

## Uses of HttpHeaders in org.springframework.http.converter.json

Methods in org.springframework.http.converter.json that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
MappingJacksonInputMessage.`getHeaders()`
Constructors in org.springframework.http.converter.json with parameters of type HttpHeaders
Modifier
Constructor
Description
``
`MappingJacksonInputMessage(InputStream body, HttpHeaders headers)`
``
`MappingJacksonInputMessage(InputStream body, HttpHeaders headers, Class<?> deserializationView)`

## Uses of HttpHeaders in org.springframework.http.converter.xml

Methods in org.springframework.http.converter.xml with parameters of type HttpHeaders
Modifier and Type
Method
Description
`protected Charset`
AbstractJaxb2HttpMessageConverter.`detectCharset(HttpHeaders httpHeaders)`
Detect the charset from the given `getContentType()`.
`protected abstract T`
AbstractXmlHttpMessageConverter.`readFromSource(Class<? extends T> clazz, HttpHeaders headers, Source source)`
Abstract template method called from `AbstractHttpMessageConverter.read(Class, HttpInputMessage)`.
`protected T`
Jaxb2CollectionHttpMessageConverter.`readFromSource(Class<? extends T> clazz, HttpHeaders headers, Source source)`
`protected Object`
Jaxb2RootElementHttpMessageConverter.`readFromSource(Class<?> clazz, HttpHeaders headers, Source source)`
`protected Object`
MarshallingHttpMessageConverter.`readFromSource(Class<?> clazz, HttpHeaders headers, Source source)`
`protected abstract void`
AbstractXmlHttpMessageConverter.`writeToResult(T t, HttpHeaders headers, Result result)`
Abstract template method called from `AbstractXmlHttpMessageConverter.writeInternal(Object, HttpOutputMessage)`.
`protected void`
Jaxb2CollectionHttpMessageConverter.`writeToResult(T t, HttpHeaders headers, Result result)`
`protected void`
Jaxb2RootElementHttpMessageConverter.`writeToResult(Object value, HttpHeaders headers, Result result)`
`protected void`
MarshallingHttpMessageConverter.`writeToResult(Object o, HttpHeaders headers, Result result)`

## Uses of HttpHeaders in org.springframework.http.server

Methods in org.springframework.http.server that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
DelegatingServerHttpResponse.`getHeaders()`
`HttpHeaders`
ServletServerHttpRequest.`getHeaders()`
`HttpHeaders`
ServletServerHttpResponse.`getHeaders()`

## Uses of HttpHeaders in org.springframework.http.server.reactive

Methods in org.springframework.http.server.reactive that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
AbstractServerHttpRequest.`getHeaders()`
`HttpHeaders`
AbstractServerHttpResponse.`getHeaders()`
`HttpHeaders`
ServerHttpRequestDecorator.`getHeaders()`
`HttpHeaders`
ServerHttpResponseDecorator.`getHeaders()`
Method parameters in org.springframework.http.server.reactive with type arguments of type HttpHeaders
Modifier and Type
Method
Description
`ServerHttpRequest.Builder`
ServerHttpRequest.Builder.`headers(Consumer<HttpHeaders> headersConsumer)`
Manipulate request headers.
Constructors in org.springframework.http.server.reactive with parameters of type HttpHeaders
Modifier
Constructor
Description
``
`AbstractListenerServerHttpResponse(org.springframework.core.io.buffer.DataBufferFactory bufferFactory, HttpHeaders headers)`
``
`AbstractServerHttpResponse(org.springframework.core.io.buffer.DataBufferFactory dataBufferFactory, HttpHeaders headers)`

## Uses of HttpHeaders in org.springframework.web

Methods in org.springframework.web that return HttpHeaders
Modifier and Type
Method
Description
`default HttpHeaders`
ErrorResponse.`getHeaders()`
Return headers to use for the response.
`HttpHeaders`
ErrorResponseException.`getHeaders()`
`HttpHeaders`
HttpMediaTypeNotAcceptableException.`getHeaders()`
`HttpHeaders`
HttpMediaTypeNotSupportedException.`getHeaders()`
`HttpHeaders`
HttpRequestMethodNotSupportedException.`getHeaders()`
Method parameters in org.springframework.web with type arguments of type HttpHeaders
Modifier and Type
Method
Description
`ErrorResponse.Builder`
ErrorResponse.Builder.`headers(Consumer<HttpHeaders> headersConsumer)`
Manipulate this response's headers with the given consumer.

## Uses of HttpHeaders in org.springframework.web.client

Methods in org.springframework.web.client that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
RestClientResponseException.`getResponseHeaders()`
Return the HTTP response headers.
`HttpHeaders`
UnknownContentTypeException.`getResponseHeaders()`
Return the HTTP response headers.
`HttpHeaders`
RestOperations.`headForHeaders(String url, Object... uriVariables)`
Retrieve all headers of the resource specified by the URI template.
`HttpHeaders`
RestOperations.`headForHeaders(String url, Map<String,?> uriVariables)`
Retrieve all headers of the resource specified by the URI template.
`HttpHeaders`
RestOperations.`headForHeaders(URI url)`
Retrieve all headers of the resource specified by the URL.
`HttpHeaders`
RestTemplate.`headForHeaders(String url, Object... uriVariables)`
`HttpHeaders`
RestTemplate.`headForHeaders(String url, Map<String,?> uriVariables)`
`HttpHeaders`
RestTemplate.`headForHeaders(URI url)`
Methods in org.springframework.web.client that return types with arguments of type HttpHeaders
Modifier and Type
Method
Description
`protected ResponseExtractor<HttpHeaders>`
RestTemplate.`headersExtractor()`
Return a response extractor for `HttpHeaders`.
Methods in org.springframework.web.client with parameters of type HttpHeaders
Modifier and Type
Method
Description
`static HttpClientErrorException`
HttpClientErrorException.`create(String message, HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] body, Charset charset)`
Variant of `HttpClientErrorException.create(HttpStatusCode, String, HttpHeaders, byte[], Charset)` with an optional prepared message.
`static HttpClientErrorException`
HttpClientErrorException.`create(HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] body, Charset charset)`
Create `HttpClientErrorException` or an HTTP status specific subclass.
`static HttpServerErrorException`
HttpServerErrorException.`create(String message, HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] body, Charset charset)`
Variant of `HttpServerErrorException.create(String, HttpStatusCode, String, HttpHeaders, byte[], Charset)` with an optional prepared message.
`static HttpServerErrorException`
HttpServerErrorException.`create(HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] body, Charset charset)`
Create an `HttpServerErrorException` or an HTTP status specific subclass.
Method parameters in org.springframework.web.client with type arguments of type HttpHeaders
Modifier and Type
Method
Description
`RestClient.Builder`
RestClient.Builder.`defaultHeaders(Consumer<HttpHeaders> headersConsumer)`
Provide a consumer to access to every default header declared so far, with the possibility to add, replace, or remove.
`S`
RestClient.RequestHeadersSpec.`headers(Consumer<HttpHeaders> headersConsumer)`
Provides access to every header declared so far with the possibility to add, replace, or remove values.
Constructors in org.springframework.web.client with parameters of type HttpHeaders
Modifier
Constructor
Description
``
`HttpClientErrorException(String message, HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] body, Charset responseCharset)`
Constructor with a status code and status text, headers, and content, and a prepared message.
``
`HttpClientErrorException(HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] body, Charset responseCharset)`
Constructor with a status code and status text, headers, and content.
``
`HttpServerErrorException(String message, HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] body, Charset charset)`
Constructor with a status code and status text, headers, content, and a prepared message.
``
`HttpServerErrorException(HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] body, Charset charset)`
Constructor with a status code and status text, headers, and content.
`protected`
`HttpStatusCodeException(String message, HttpStatusCode statusCode, String statusText, HttpHeaders responseHeaders, byte[] responseBody, Charset responseCharset)`
Construct instance with an `HttpStatusCode`, status text, content, and a response charset.
`protected`
`HttpStatusCodeException(HttpStatusCode statusCode, String statusText, HttpHeaders responseHeaders, byte[] responseBody, Charset responseCharset)`
Construct instance with an `HttpStatusCode`, status text, content, and a response charset.
``
`RestClientResponseException(String message, int statusCode, String statusText, HttpHeaders headers, byte[] responseBody, Charset responseCharset)`
Construct a new instance of with the given response data.
``
`RestClientResponseException(String message, HttpStatusCode statusCode, String statusText, HttpHeaders headers, byte[] responseBody, Charset responseCharset)`
Construct a new instance of with the given response data.
``
`UnknownContentTypeException(Type targetType, MediaType contentType, int statusCode, String statusText, HttpHeaders responseHeaders, byte[] responseBody)`
Construct a new instance of with the given response data.
``
`UnknownContentTypeException(Type targetType, MediaType contentType, HttpStatusCode statusCode, String statusText, HttpHeaders responseHeaders, byte[] responseBody)`
Construct a new instance of with the given response data.
``
`UnknownHttpStatusCodeException(int rawStatusCode, String statusText, HttpHeaders responseHeaders, byte[] responseBody, Charset responseCharset)`
Construct a new instance of `HttpStatusCodeException` based on a status code, status text, and response body content.
``
`UnknownHttpStatusCodeException(String message, int rawStatusCode, String statusText, HttpHeaders responseHeaders, byte[] responseBody, Charset responseCharset)`
Construct a new instance of `HttpStatusCodeException` based on a status code, status text, and response body content.

## Uses of HttpHeaders in org.springframework.web.client.support

Methods in org.springframework.web.client.support that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
RestClientAdapter.`exchangeForHeaders(HttpRequestValues values)`
`HttpHeaders`
RestTemplateAdapter.`exchangeForHeaders(HttpRequestValues values)`

## Uses of HttpHeaders in org.springframework.web.multipart

Methods in org.springframework.web.multipart that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
MultipartHttpServletRequest.`getMultipartHeaders(String paramOrFileName)`
Return the headers for the specified part of the multipart request.
`HttpHeaders`
MultipartHttpServletRequest.`getRequestHeaders()`
Return this request's headers as a convenient HttpHeaders instance.

## Uses of HttpHeaders in org.springframework.web.multipart.support

Methods in org.springframework.web.multipart.support that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
RequestPartServletServerHttpRequest.`getHeaders()`
`HttpHeaders`
DefaultMultipartHttpServletRequest.`getMultipartHeaders(String paramOrFileName)`
`HttpHeaders`
StandardMultipartHttpServletRequest.`getMultipartHeaders(String paramOrFileName)`
`HttpHeaders`
AbstractMultipartHttpServletRequest.`getRequestHeaders()`

## Uses of HttpHeaders in org.springframework.web.server

Methods in org.springframework.web.server that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
MethodNotAllowedException.`getHeaders()`
Return HttpHeaders with an "Allow" header that documents the allowed HTTP methods for this URL, if available, or an empty instance otherwise.
`HttpHeaders`
NotAcceptableStatusException.`getHeaders()`
Return HttpHeaders with an "Accept" header that documents the supported media types, if available, or an empty instance otherwise.
`HttpHeaders`
ResponseStatusException.`getHeaders()`
Return headers to add to the error response, for example, "Allow", "Accept", etc.
`HttpHeaders`
UnsupportedMediaTypeStatusException.`getHeaders()`
Return HttpHeaders with an "Accept" header that documents the supported media types, if available, or an empty instance otherwise.
`HttpHeaders`
MethodNotAllowedException.`getResponseHeaders()`
Deprecated.
as of 6.0 in favor of `MethodNotAllowedException.getHeaders()`
`HttpHeaders`
NotAcceptableStatusException.`getResponseHeaders()`
Deprecated.
as of 6.0 in favor of `NotAcceptableStatusException.getHeaders()`
`HttpHeaders`
ResponseStatusException.`getResponseHeaders()`
Deprecated.
as of 6.0 in favor of `ResponseStatusException.getHeaders()`
`HttpHeaders`
UnsupportedMediaTypeStatusException.`getResponseHeaders()`
Deprecated.
as of 6.0 in favor of `UnsupportedMediaTypeStatusException.getHeaders()`

## Uses of HttpHeaders in org.springframework.web.service.invoker

Methods in org.springframework.web.service.invoker that return HttpHeaders
Modifier and Type
Method
Description
`HttpHeaders`
AbstractReactorHttpExchangeAdapter.`exchangeForHeaders(HttpRequestValues requestValues)`
`HttpHeaders`
HttpExchangeAdapter.`exchangeForHeaders(HttpRequestValues requestValues)`
Perform the given request, release the response content, and return the response headers.
`HttpHeaders`
HttpRequestValues.`getHeaders()`
Return the headers for the request, if any.
Methods in org.springframework.web.service.invoker that return types with arguments of type HttpHeaders
Modifier and Type
Method
Description
`reactor.core.publisher.Mono<HttpHeaders>`
ReactorHttpExchangeAdapter.`exchangeForHeadersMono(HttpRequestValues requestValues)`
Perform the given request, release the response content, and return the response headers.
`reactor.core.publisher.Mono<HttpHeaders>`
AbstractReactorHttpExchangeAdapter.`requestToHeaders(HttpRequestValues requestValues)`
`reactor.core.publisher.Mono<HttpHeaders>`
HttpClientAdapter.`requestToHeaders(HttpRequestValues requestValues)`
Deprecated, for removal: This API element is subject to removal in a future version.
Perform the given request, release the response content, and return the response headers.
Methods in org.springframework.web.service.invoker with parameters of type HttpHeaders
Modifier and Type
Method
Description
`protected HttpRequestValues`
HttpRequestValues.Builder.`createRequestValues(HttpMethod httpMethod, URI uri, UriBuilderFactory uriBuilderFactory, String uriTemplate, Map<String,String> uriVars, HttpHeaders headers, org.springframework.util.MultiValueMap<String,String> cookies, Map<String,Object> attributes, Object bodyValue)`
Create `HttpRequestValues` from values passed to the `HttpRequestValues.Builder`.
`protected ReactiveHttpRequestValues`
ReactiveHttpRequestValues.Builder.`createRequestValues(HttpMethod httpMethod, URI uri, UriBuilderFactory uriBuilderFactory, String uriTemplate, Map<String,String> uriVars, HttpHeaders headers, org.springframework.util.MultiValueMap<String,String> cookies, Map<String,Object> attributes, Object bodyValue)`
Constructors in org.springframework.web.service.invoker with parameters of type HttpHeaders
Modifier
Constructor
Description
`protected`
`HttpRequestValues(HttpMethod httpMethod, URI uri, UriBuilderFactory uriBuilderFactory, String uriTemplate, Map<String,String> uriVariables, HttpHeaders headers, org.springframework.util.MultiValueMap<String,String> cookies, Map<String,Object> attributes, Object bodyValue)`
Construct `HttpRequestValues`.

## Uses of HttpHeaders in org.springframework.web.util

Methods in org.springframework.web.util with parameters of type HttpHeaders
Modifier and Type
Method
Description
`static UriComponentsBuilder`
ForwardedHeaderUtils.`adaptFromForwardedHeaders(URI uri, HttpHeaders headers)`
Adapt the scheme+host+port of the given `URI` from the "Forwarded" header (see RFC 7239) or from the "X-Forwarded-Host", "X-Forwarded-Port", and "X-Forwarded-Proto" headers if "Forwarded" is not present.
`static InetSocketAddress`
ForwardedHeaderUtils.`parseForwardedFor(URI uri, HttpHeaders headers, InetSocketAddress remoteAddress)`
Parse the first "Forwarded: for=..." or "X-Forwarded-For" header value to an `InetSocketAddress` representing the address of the client.